Imports System.Math
'Imports System
Imports System.IO


Public Class MBmp
    Private Width As Integer
    Private Height As Integer
    Private RowWidth As Integer
    Private DataLen As Integer
    Private BmpData() As Byte

#Region "New"

    Public Sub New()
        Dim TBmpD(2) As Byte
        Me.Width = 1
        Me.Height = 1
        Me.RowWidth = Width * 3
        Me.DataLen = Height * Width * 3
        Me.BmpData = TBmpD
        TBmpD = Nothing
    End Sub

    Public Sub New(ByVal Width As Integer, ByVal Height As Integer)
        Me.Width = Width
        Me.Height = Height
        Me.RowWidth = Width * 3
        Me.DataLen = Me.Height * Width * 3
        Dim TBmpD(Me.DataLen - 1) As Byte
        Me.BmpData = TBmpD
        TBmpD = Nothing
    End Sub

    Public Sub New(ByVal Width As Integer, ByVal Height As Integer, ByVal BitmapColor As Color)
        Me.Width = Width
        Me.Height = Height
        Me.RowWidth = Width * 3
        Me.DataLen = Height * Width * 3
        Dim TBmpD(Me.DataLen - 1) As Byte
        Dim Tcolor(2) As Byte
        Tcolor(2) = BitmapColor.R
        Tcolor(0) = BitmapColor.B
        Tcolor(1) = BitmapColor.G
        For Y As Integer = 0 To Me.DataLen - 3 Step 3
            Array.Copy(Tcolor, 0, TBmpD, Y, 3)
        Next
        Me.BmpData = TBmpD
        TBmpD = Nothing
    End Sub

    Public Sub New(ByVal BitmapFile As String)
        'Check to make sure it exists
        Dim Tbm As New Bitmap(BitmapFile)
        Me.Width = Tbm.Width
        Me.Height = Tbm.Height
        Me.RowWidth = Width * 3
        Me.DataLen = Height * Width * 3
        Dim TBmp(Me.DataLen - 1) As Byte
        Dim X As Integer : Dim Y As Integer
        Dim CIndex As Integer = 0
        Dim TColor As Color

        If Int(Tbm.Width / 4) = Tbm.Width / 4 And Tbm.PixelFormat = Imaging.PixelFormat.Format24bppRgb _
            And Tbm.RawFormat.GetHashCode = -1102893738 Then
            ' Lock the bitmap data.
            LockBitmap(Tbm, MemRead)
            TBmp = g_PixBytes.Clone
            ' UnLock the bitmap data.
            UnlockBitmap(Tbm, MemRead)
        Else
            For Y = 0 To Me.Height - 1
                For X = 0 To Me.Width - 1
                    TColor = Tbm.GetPixel(X, Y)
                    TBmp(CIndex) = TColor.B
                    TBmp(CIndex + 1) = TColor.G
                    TBmp(CIndex + 2) = TColor.R
                    CIndex = CIndex + 3
                Next
            Next
        End If

        Me.BmpData = TBmp
        Tbm = Nothing
        TBmp = Nothing
    End Sub

    Public Sub New(ByVal BitmapFile As Bitmap)
        'Check to make sure it exists
        Me.Width = BitmapFile.Width
        Me.Height = BitmapFile.Height
        Me.RowWidth = Width * 3
        Me.DataLen = Me.Height * Width * 3
        Dim TBmp(Me.DataLen - 1) As Byte
        Dim X As Integer : Dim Y As Integer
        Dim CIndex As Integer = 0
        Dim TColor As Color

        If Int(BitmapFile.Width / 4) = BitmapFile.Width / 4 And BitmapFile.PixelFormat = Imaging.PixelFormat.Format24bppRgb _
            And BitmapFile.RawFormat.GetHashCode = -1102893738 Then
            ' Lock the bitmap data.
            LockBitmap(BitmapFile, MemRead)
            TBmp = g_PixBytes.Clone
            ' UnLock the bitmap data.
            UnlockBitmap(BitmapFile, MemRead)
        Else
            For Y = 0 To Me.Height - 1
                For X = 0 To Me.Width - 1
                    TColor = BitmapFile.GetPixel(X, Y)
                    TBmp(CIndex) = TColor.B
                    TBmp(CIndex + 1) = TColor.G
                    TBmp(CIndex + 2) = TColor.R
                    CIndex = CIndex + 3
                Next
            Next
        End If

        Me.BmpData = TBmp
        TBmp = Nothing
    End Sub

#End Region


    Public Function ConvertToBitmap()
        Dim Tbitmap As New Bitmap(Me.Width, Me.Height)
        If Int(Me.Width / 4) = Me.Width / 4 Then
            LockBitmap(Tbitmap, MemWrite)
            g_PixBytes = Me.BmpData  '.Clone
            UnlockBitmap(Tbitmap, MemWrite)
        Else
            Dim X As Integer : Dim Y As Integer
            Dim YIndex As Integer : Dim XIndex As Integer
            For Y = 0 To Me.Height - 1
                YIndex = 3 * Me.Width * Y
                For X = 0 To Me.Width - 1
                    XIndex = YIndex + (X * 3)
                    Tbitmap.SetPixel(X, Y, Color.FromArgb(Me.BmpData(XIndex + 2), Me.BmpData(XIndex + 1), Me.BmpData(XIndex)))
                Next
            Next
        End If
        ConvertToBitmap = Tbitmap
    End Function

    Public Sub FromBitmap(ByVal Image1 As Bitmap)
        Me.Height = Image1.Height
        Me.Width = Image1.Width
        Me.RowWidth = Width * 3
        Me.DataLen = Width * Height * 3
        Dim TBmpD(Me.DataLen - 1) As Byte

        If Int(Image1.Width / 4) = Image1.Width / 4 And Image1.PixelFormat = Imaging.PixelFormat.Format24bppRgb _
            And Image1.RawFormat.GetHashCode = -1102893738 Then
            LockBitmap(Image1, MemRead)
            TBmpD = g_PixBytes.Clone
            UnlockBitmap(Image1, MemRead)
        Else
            Dim X As Integer : Dim Y As Integer
            Dim YIndex As Integer : Dim XIndex As Integer
            Dim TColor As Color
            For Y = 0 To Me.Height - 1
                YIndex = 3 * Me.Width * Y
                For X = 0 To Me.Width - 1
                    XIndex = YIndex + (X * 3)
                    TColor = Image1.GetPixel(X, Y)
                    TBmpD(XIndex) = TColor.B
                    TBmpD(XIndex + 1) = TColor.G
                    TBmpD(XIndex + 2) = TColor.R
                Next
            Next
        End If
        Me.BmpData = TBmpD
    End Sub

    Public Function Crop(ByVal StartPoint As Point, ByVal EndPoint As Point)
        If StartPoint.X > EndPoint.X Or StartPoint.Y > EndPoint.Y Or StartPoint.X < 0 _
        Or StartPoint.Y < 0 Or EndPoint.X >= Me.Width Or EndPoint.Y >= Me.Height Then
            Dim TMBmp1 As New MBmp(0, 0)
            Return TMBmp1
        End If
        Dim Width As Integer = EndPoint.X - StartPoint.X + 1
        Dim Height As Integer = EndPoint.Y - StartPoint.Y + 1
        Dim TMBmp As New MBmp(Width, Height)
        Dim XOffset As Integer : Dim YOffset As Integer : Dim TYOffset As Integer
        Dim Y As Integer : Dim ArrayWidth As Integer = Width * 3


        For Y = 0 To Height - 1
            YOffset = (Y + StartPoint.Y) * Me.Width * 3 'me row offset
            TYOffset = Y * ArrayWidth 'tmbmp row offset
            XOffset = StartPoint.X * 3 + YOffset
            Array.Copy(Me.BmpData, XOffset, TMBmp.BmpData, TYOffset, ArrayWidth)
        Next

        Return TMBmp
    End Function

    Public Function Scale(ByVal Change As Single)
        If Me.Width < 1 Or Me.Height < 1 Or Change <= 0 Then Exit Function
        Dim Orig As Bitmap
        Orig = Me.ConvertToBitmap
        Dim bm_dest As New Bitmap(CInt(Me.Width * Change), CInt(Me.Height * Change))
        Dim gr_dest As Graphics = Graphics.FromImage(bm_dest)
        gr_dest.DrawImage(Orig, 0, 0, bm_dest.Width + 1, bm_dest.Height + 1)
        Dim SurfBMP As New MBmp(bm_dest)
        Orig = Nothing
        bm_dest = Nothing
        gr_dest = Nothing
        Return SurfBMP
    End Function

    Public Function Clone()
        Dim Dest As New MBmp(Me.GetWidth, Me.GetHeight)
        Dest.SetBMPData(Me.GetBMPData)
        Return Dest
        Dest = Nothing
    End Function

    Public Sub PasteOnTo(ByVal PastePoint As Point, ByVal OverLay As MBmp)
        Dim SPoint, EPoint As Point
        Dim SCrop, ECrop As Point
        SPoint.X = PastePoint.X - CInt(OverLay.Width / 2) : SPoint.Y = PastePoint.Y - CInt(OverLay.Height / 2)
        EPoint.X = SPoint.X + OverLay.Width - 1 : EPoint.Y = SPoint.Y + OverLay.Height - 1
        SCrop.X = 0 : SCrop.Y = 0 : ECrop.X = OverLay.Width - 1 : ECrop.Y = OverLay.Height - 1

        If SPoint.X >= Me.Width Or SPoint.Y >= Me.Height Or EPoint.X < 0 Or EPoint.Y < 0 Then Exit Sub

        'Crop
        If Me.Width < SPoint.X + OverLay.Width Then ECrop.X = Me.Width - 1 - SPoint.X
        If Me.Height < SPoint.Y + OverLay.Height Then ECrop.Y = Me.Height - 1 - SPoint.Y
        If SPoint.X < 0 Then
            SCrop.X = Abs(SPoint.X)
            SPoint.X = 0
        End If
        If SPoint.Y < 0 Then
            SCrop.Y = Abs(SPoint.Y)
            SPoint.Y = 0
        End If

        Dim OOffset, COffset, ArrayWidth As Integer
        ArrayWidth = (ECrop.X - SCrop.X + 1) * 3
        For Y As Integer = 0 To ECrop.Y - SCrop.Y
            OOffset = (Y + SPoint.Y) * (Me.Width * 3) + (SPoint.X * 3)
            COffset = (Y + SCrop.Y) * (OverLay.Width * 3) + (SCrop.X * 3)
            Array.Copy(OverLay.BmpData, COffset, Me.BmpData, OOffset, ArrayWidth)
        Next
    End Sub

    'No left, right, or up off screen
    Public Sub PasteOnTo(ByRef PastePoint As Point, ByRef OverLay As VBMP, ByRef Direction As Integer)
        Dim CurPosMBmp As Integer = (PastePoint.Y * Me.RowWidth) + (PastePoint.X * 3)
        Dim CurRowMBmp As Integer = PastePoint.Y * Me.RowWidth
        Dim CurPosVBMP As Integer = 0
        Dim CurRowVBMP As Integer = 0
        Dim NextRowVBMP As Integer = OverLay.GetRowWidth
        Dim VBMPDataIndex As Integer = 0
        Dim VBMPDataSegLen As Integer
        Dim NextPosVBMP As Integer
        Dim IntArray(3) As Byte
        Dim OverlayData() As Byte
        Dim OverlayDataLen As Integer

        If Direction = 0 Then 'normal
            OverlayData = OverLay.GetVBMPDataRef
            OverlayDataLen = OverLay.GetDataLen
        ElseIf Direction = 1 And OverLay.IsReversable = True Then  'reverse
            OverlayData = OverLay.GetVBMPRevDataRef
            OverlayDataLen = OverLay.GetDataLenR
        ElseIf Direction = 1 And OverLay.IsReversable = False Then
            Exit Sub
        End If

        'Bounding
        If PastePoint.X < 0 Or PastePoint.X + OverLay.GetWidth > Me.Width Then
            Exit Sub
        End If
        If PastePoint.Y < 0 Or PastePoint.Y >= Me.Height Then
            Exit Sub
        End If

        'Get to start point
        Array.Copy(OverlayData, VBMPDataIndex, IntArray, 0, 4)
        CurPosVBMP = BytesToInteger(IntArray)
        Array.Copy(OverlayData, VBMPDataIndex + 4, IntArray, 0, 4)
        VBMPDataSegLen = BytesToInteger(IntArray)
        VBMPDataIndex = VBMPDataIndex + 8

        'Start the paste
        Do While VBMPDataIndex < OverlayDataLen And CurRowMBmp < Me.DataLen
            If CurPosVBMP >= NextRowVBMP Then
                CurRowMBmp = CurRowMBmp + Me.RowWidth
                CurRowVBMP = NextRowVBMP
                NextRowVBMP = NextRowVBMP + OverLay.GetRowWidth
            Else
                'process  
                If VBMPDataSegLen + CurPosVBMP > NextRowVBMP Then
                    'cut segment
                    Dim TempDataLen As Integer = NextRowVBMP - CurPosVBMP
                    CurPosMBmp = CurRowMBmp + (CurPosVBMP - CurRowVBMP) + (PastePoint.X * 3)
                    Array.Copy(OverlayData, VBMPDataIndex, Me.BmpData, CurPosMBmp, TempDataLen)
                    VBMPDataIndex = VBMPDataIndex + TempDataLen
                    CurPosVBMP = NextRowVBMP
                    CurRowVBMP = NextRowVBMP
                    NextRowVBMP = NextRowVBMP + OverLay.GetRowWidth
                    VBMPDataSegLen = VBMPDataSegLen - TempDataLen
                    CurRowMBmp = CurRowMBmp + Me.RowWidth
                    If VBMPDataIndex >= OverlayDataLen Then
                        Exit Do
                    End If
                    'Exit Sub 'remove later
                Else
                    CurPosMBmp = CurRowMBmp + (CurPosVBMP - CurRowVBMP) + (PastePoint.X * 3)
                    Array.Copy(OverlayData, VBMPDataIndex, Me.BmpData, CurPosMBmp, VBMPDataSegLen)
                    VBMPDataIndex = VBMPDataIndex + VBMPDataSegLen
                    If VBMPDataIndex >= OverlayDataLen Then
                        Exit Do
                    End If
                    Array.Copy(OverlayData, VBMPDataIndex, IntArray, 0, 4)
                    CurPosVBMP = BytesToInteger(IntArray)
                    Array.Copy(OverlayData, VBMPDataIndex + 4, IntArray, 0, 4)
                    VBMPDataSegLen = BytesToInteger(IntArray)
                    VBMPDataIndex = VBMPDataIndex + 8
                End If
            End If
        Loop
        
    End Sub


#Region "Access Data"

    'Not Tested
    Public Function GetPixels(ByVal StartPoint As Point, ByVal EndPoint As Point)
        Dim ByteData(0) As Byte
        ByteData(0) = 0
        If StartPoint.X > EndPoint.X Or StartPoint.Y > EndPoint.Y Then
            MsgBox("The start point of MBmp select must be less then the end point.")
            Return ByteData
        End If
        If StartPoint.X < 0 Or EndPoint.X > Me.Width - 1 Or StartPoint.Y < 0 Or EndPoint.Y > Me.Height - 1 Then
            MsgBox("The selected area of the MBmp is not valid.")
            Return ByteData
        End If
        Dim LData As Integer
        LData = 3 * (Int(EndPoint.X) - Int(StartPoint.X) + 1) * (Int(EndPoint.Y) - Int(StartPoint.Y) + 1) - 1
        ReDim ByteData(LData)
        Dim Count As Integer = 0
        Dim YIndex As Integer
        For Y As Integer = Int(StartPoint.Y) To Int(EndPoint.Y)
            YIndex = Y * Me.Width * 3
            For X As Integer = 3 * Int(StartPoint.X) To 3 * Int(EndPoint.X) Step 3
                ByteData(Count) = Me.BmpData(YIndex + X)
                ByteData(Count + 1) = Me.BmpData(YIndex + X + 1)
                ByteData(Count + 2) = Me.BmpData(YIndex + X + 2)
                Count = Count + 3
            Next
        Next
        Return ByteData
    End Function

    Public Function GetBMPData()
        If Me.Height > 0 And Me.Width > 0 Then
            Return Me.BmpData.Clone
        End If
    End Function

    Public Function GetBMPDataRef()
        If Me.Height > 0 And Me.Width > 0 Then
            Return Me.BmpData
        End If
    End Function

    Public Function GetWidth()
        Return Me.Width
    End Function

    Public Function GetHeight()
        Return Me.Height
    End Function

    Public Function GetRowWidth()
        GetRowWidth = RowWidth
    End Function

    Public Function GetDataLen()
        Return Me.DataLen
    End Function

    Public Function SetBMPData(ByVal Data() As Byte)
        If UBound(Data, 1) = (Me.DataLen - 1) Then
            Me.BmpData = Data.Clone
        Else
            MsgBox("The data array given does not match the size of this MBmp.")
        End If
    End Function

    Public Function SetBMPDataRef(ByVal Data() As Byte)
        If UBound(Data, 1) = (Me.DataLen - 1) Then
            Me.BmpData = Data
        Else
            MsgBox("The data array given does not match the size of this MBmp.")
        End If
    End Function

#End Region

End Class

Public Class VBMP
    Private Width As Integer
    Private Height As Integer
    Private RowWidth As Integer
    Private DataLen As Integer
    Private DataLenR As Integer
    Private Reversable As Boolean = False
    Private VBMPData() As Byte
    Private VBMPDataR() As Byte

    'For use in the functions
    Private StartIndex As Integer
    Private SegLength As Integer
    'Data formate
    'StartPoint - Int
    'SegmentLength - Int
    'Data b,g,r,b,g,r,b,g,r all bytes

#Region "New"

    Public Sub New(ByVal VBMPFile As String)
        Dim DLen As Integer
        Dim FileType As Integer

        FileOpen(1, VBMPFile, OpenMode.Binary, OpenAccess.Read)
        FileGet(1, FileType)
        If FileType = 0 Then
            FileGet(1, Width)
            FileGet(1, Height)
            Me.RowWidth = Width * 3
            FileGet(1, DLen)
            Me.DataLen = DLen
            Dim TArray(DataLen - 1) As Byte
            FileGet(1, TArray)
            Me.VBMPData = TArray
            TArray = Nothing
        Else
            MsgBox("Not a valid .vbmp file for this operation.")
            Me.Height = 0
            Me.Width = 0
        End If
        FileClose(1)

    End Sub

    Public Sub New(ByVal VBMPDataFile As String, ByRef RefImage As Bitmap)
        Dim DLen As Integer
        Dim SourceMBMPData() As Byte
        SourceMBMPData = New MBmp(RefImage).GetBMPData
        Dim FileType As Integer
        Dim VDataStart(3) As Byte
        Dim VDataLen(3) As Byte
        Dim ArrayIndex As Integer = 0
        Dim IntToByteArray(3) As Byte

        FileOpen(1, VBMPDataFile, OpenMode.Binary, OpenAccess.Read)
        FileGet(1, FileType)
        If FileType = 1 Then
            FileGet(1, Width)
            FileGet(1, Height)
            Me.RowWidth = Width * 3
            FileGet(1, DLen)
            Me.DataLen = DLen
            Dim TArray(DataLen - 1) As Byte
            Do Until EOF(1)
                FileGet(1, VDataStart)
                FileGet(1, VDataLen)
                Array.Copy(VDataStart, 0, TArray, ArrayIndex, 4)
                Array.Copy(VDataLen, 0, TArray, ArrayIndex + 4, 4)
                Array.Copy(SourceMBMPData, BytesToInteger(VDataStart), TArray, ArrayIndex + 8, BytesToInteger(VDataLen))
                ArrayIndex = ArrayIndex + 8 + BytesToInteger(VDataLen)
            Loop
            Me.VBMPData = TArray
            TArray = Nothing
            SourceMBMPData = Nothing
        Else
            MsgBox("Not a valid .vbmp file for this operation.")
            Me.Height = 0
            Me.Width = 0
        End If
        FileClose(1)
    End Sub

    Public Sub New(ByRef RefImage As Bitmap, ByVal TransparentColor As Color)
        Me.Width = RefImage.Width
        Me.Height = RefImage.Height
        Me.RowWidth = Width * 3
        Dim Image As New MBmp(RefImage)
        Dim ImgData() As Byte = Image.GetBMPData
        Dim TDLen As Integer = Image.GetDataLen
        Dim TempVData(TDLen + 1000) As Byte
        Image = Nothing
        Dim TransColor(2) As Byte 'B,G,R
        TransColor(0) = TransparentColor.B
        TransColor(1) = TransparentColor.G
        TransColor(2) = TransparentColor.R
        Dim VDataPos As Integer = 0
        Dim StartPos, RunLen As Integer

        'Compile Data
        For I As Integer = 0 To (RowWidth * Height) - 1 Step 3
            If ImgData(I) <> TransColor(0) Or ImgData(I + 1) <> TransColor(1) Or ImgData(I + 2) <> TransColor(2) Then
                StartPos = I
                RunLen = 0
                Do
                    I = I + 3
                    RunLen = RunLen + 3
                Loop Until (ImgData(I) = TransColor(0) And ImgData(I + 1) = TransColor(1) And ImgData(I + 2) = TransColor(2)) Or (I + 3) = TDLen
                'add pos
                Array.Copy(IntegerToBytes(StartPos), 0, TempVData, VDataPos, 4)
                'add len
                Array.Copy(IntegerToBytes(RunLen), 0, TempVData, VDataPos + 4, 4)
                'add data
                Array.Copy(ImgData, StartPos, TempVData, VDataPos + 8, RunLen)
                VDataPos = VDataPos + RunLen + 8
            End If
        Next

        Dim Tarray(VDataPos - 1) As Byte
        Array.Copy(TempVData, Tarray, VDataPos)
        Me.VBMPData = Tarray
        Me.DataLen = VDataPos
        ImgData = Nothing
    End Sub

#End Region


    Public Sub SaveToFile(ByVal FileName As String, ByVal FileType As Integer)
        If FileType = 0 Or FileType = 1 Then
            'FileOpen(1, FileName, OpenMode.Binary, OpenAccess.Write)
            File.Delete(FileName)
            FileOpen(1, FileName, OpenMode.Binary)
            FilePut(1, FileType)
            FilePut(1, Width)
            FilePut(1, Height)
            FilePut(1, DataLen)

            If FileType = 0 Then
                FilePut(1, VBMPData)
            Else
                Dim TArray(7) As Byte
                Dim LArray(3) As Byte
                Dim VIndex As Integer = 0
                Dim Length As Integer

                Do Until VIndex >= UBound(VBMPData, 1)
                    Array.Copy(VBMPData, VIndex + 4, LArray, 0, 4)
                    Length = BytesToInteger(LArray)
                    Array.Copy(VBMPData, VIndex, TArray, 0, 8)
                    FilePut(1, TArray)
                    VIndex = VIndex + Length + 8
                Loop
            End If

            FileClose(1)
        Else
            MsgBox("Not a valid file type for the VBMP file")
        End If
    End Sub

    Public Sub MakeReversable()
        If Reversable = False Then
            Dim TArray(Me.RowWidth * Me.Height - 1) As Byte
            Dim FlipArray(Me.RowWidth - 1) As Byte
            Dim FlipMask(Me.Width - 1) As Byte
            Dim TransMask(Me.Width * Me.Height - 1) As Byte
            Dim IntArray(3) As Byte
            Dim TColor(2) As Byte
            Dim VBMPDataIndex As Integer = 0
            Dim VBMPDataSegLen As Integer
            Dim CurPosVBMP As Integer = 0
            Dim CurRowVBMP As Integer = 0
            Dim I, J As Integer

            'load data into temp array
            Do Until VBMPDataIndex >= Me.DataLen
                'Get to start point
                Array.Copy(Me.VBMPData, VBMPDataIndex, IntArray, 0, 4)
                CurPosVBMP = BytesToInteger(IntArray)
                Array.Copy(Me.VBMPData, VBMPDataIndex + 4, IntArray, 0, 4)
                VBMPDataSegLen = BytesToInteger(IntArray)
                VBMPDataIndex = VBMPDataIndex + 8
                Array.Copy(Me.VBMPData, VBMPDataIndex, TArray, CurPosVBMP, VBMPDataSegLen)
                For I = Int(CurPosVBMP / 3) To Int((CurPosVBMP + VBMPDataSegLen) / 3) - 1
                    TransMask(I) = 1
                Next
                VBMPDataIndex = VBMPDataIndex + VBMPDataSegLen
            Loop

            'Flip the image in TArray
            For I = 0 To (Me.RowWidth * Me.Height - 1) Step Me.RowWidth
                For J = 0 To Me.Width - 1
                    Array.Copy(TArray, I + (J * 3), FlipArray, Me.RowWidth - ((J + 1) * 3), 3)
                Next
                Array.Copy(FlipArray, 0, TArray, I, Me.RowWidth)
            Next
            For I = 0 To (Me.Width * Me.Height - 1) Step Me.Width
                For J = 0 To Me.Width - 1
                    FlipMask(J) = TransMask(I + Me.Width - J - 1)
                Next
                Array.Copy(FlipMask, 0, TransMask, I, Me.Width)
            Next

            'Create VBMPDataR
            Dim StartPos, RunLen As Integer
            Dim VDataPos As Integer = 0
            Dim TempVData(Me.RowWidth * Me.Height + 1000) As Byte
            For I = 0 To (Me.Width * Me.Height) - 1
                If TransMask(I) = 1 Then
                    StartPos = I * 3
                    RunLen = 0
                    Do
                        I = I + 1
                        RunLen = RunLen + 3
                    Loop Until TransMask(I) = 0
                    'add pos
                    Array.Copy(IntegerToBytes(StartPos), 0, TempVData, VDataPos, 4)
                    'add len
                    Array.Copy(IntegerToBytes(RunLen), 0, TempVData, VDataPos + 4, 4)
                    'add data
                    Array.Copy(TArray, StartPos, TempVData, VDataPos + 8, RunLen)
                    VDataPos = VDataPos + RunLen + 8
                End If
            Next
            Dim TTarray(VDataPos - 1) As Byte
            Array.Copy(TempVData, TTarray, VDataPos)
            Me.VBMPDataR = TTarray
            Me.DataLenR = VDataPos
            Me.Reversable = True
            TArray = Nothing
            FlipArray = Nothing
            TransMask = Nothing
        End If
    End Sub


#Region "Access Data"

    Public Function GetVBMPDataRef()
        If Me.Height > 0 And Me.Width > 0 Then
            Return Me.VBMPData
        End If
    End Function

    Public Function GetVBMPRevDataRef()
        If Me.Height > 0 And Me.Width > 0 And Me.Reversable = True Then
            Return Me.VBMPDataR
        End If
    End Function

    Public Function GetWidth()
        Return Me.Width
    End Function

    Public Function IsReversable()
        Return Me.Reversable
    End Function

    Public Function GetHeight()
        Return Me.Height
    End Function

    Public Function GetRowWidth()
        GetRowWidth = RowWidth
    End Function

    Public Function GetDataLen()
        Return Me.DataLen
    End Function

    Public Function GetDataLenR()
        Return Me.DataLenR
    End Function

#End Region



End Class
