
Module Sound
    Private BackGround As AxWMPLib.AxWindowsMediaPlayer
    Private Voice As AxWMPLib.AxWindowsMediaPlayer
    Private SndFX As AxWMPLib.AxWindowsMediaPlayer
    Public BGVol As Integer = 50
    Public VVol As Integer = 50
    Public SFxVol As Integer = 50
    Public Const BGSnd As Integer = 0
    Public Const VSnd As Integer = 1
    Public Const SFSnd As Integer = 2

    Public Sub Init(ByRef SBG As AxWMPLib.AxWindowsMediaPlayer, ByRef SV As AxWMPLib.AxWindowsMediaPlayer, ByRef Sfx As AxWMPLib.AxWindowsMediaPlayer)
        BackGround = SBG
        Voice = SV
        SndFX = Sfx
    End Sub

#Region "Play State Functions"

    Public Sub LoadSound(ByVal SoundThread As Integer, ByVal FileLocation As String)
        If SoundThread = BGSnd Then
            BackGround.URL = FileLocation
            BackGround.Ctlcontrols.stop()
        ElseIf SoundThread = VSnd Then
            Voice.URL = FileLocation
            Voice.Ctlcontrols.stop()
        ElseIf SoundThread = SFSnd Then
            SndFX.URL = FileLocation
            SndFX.Ctlcontrols.stop()
        End If
    End Sub

    Public Sub PlaySound(ByVal SoundThread As Integer, ByVal FileLocation As String)
        If SoundThread = BGSnd Then
            BackGround.URL = FileLocation
        ElseIf SoundThread = VSnd Then
            Voice.URL = FileLocation
        ElseIf SoundThread = SFSnd Then
            SndFX.URL = FileLocation
        End If
    End Sub

    Public Sub StartSound(ByVal SoundThread As Integer)
        If SoundThread = BGSnd Then
            If BackGround.URL <> "" Then BackGround.Ctlcontrols.play()
        ElseIf SoundThread = VSnd Then
            If Voice.URL <> "" Then Voice.Ctlcontrols.play()
        ElseIf SoundThread = SFSnd Then
            If SndFX.URL <> "" Then SndFX.Ctlcontrols.play()
        End If
    End Sub

    Public Sub StopSound(ByVal SoundThread As Integer)
        If SoundThread = BGSnd Then
            BackGround.Ctlcontrols.stop()
        ElseIf SoundThread = VSnd Then
            Voice.Ctlcontrols.stop()
        ElseIf SoundThread = SFSnd Then
            SndFX.Ctlcontrols.stop()
        End If
    End Sub

    Public Sub PauseSound(ByVal SoundThread As Integer)
        If SoundThread = BGSnd Then
            BackGround.Ctlcontrols.pause()
        ElseIf SoundThread = VSnd Then
            Voice.Ctlcontrols.pause()
        ElseIf SoundThread = SFSnd Then
            SndFX.Ctlcontrols.pause()
        End If
    End Sub

    Public Sub LoopSound(ByVal SoundThread As Integer)
        If SoundThread = BGSnd Then
            BackGround.settings.setMode("Loop", True)
        ElseIf SoundThread = VSnd Then
            Voice.settings.setMode("Loop", True)
        ElseIf SoundThread = SFSnd Then
            SndFX.settings.setMode("Loop", True)
        End If
    End Sub

    Public Sub StopLoopingSound(ByVal SoundThread As Integer)
        If SoundThread = BGSnd Then
            BackGround.settings.setMode("Loop", False)
        ElseIf SoundThread = VSnd Then
            Voice.settings.setMode("Loop", False)
        ElseIf SoundThread = SFSnd Then
            SndFX.settings.setMode("Loop", False)
        End If
    End Sub

#End Region

#Region "Volume Functions"

    Public Sub FadeOut(ByVal SoundThread As Integer, ByVal Time As Double)
        Dim Start As Double = GetTimer()
        Dim Finish As Double = Start + Time   ' Set end time.
        Dim BGSVol As Integer = BackGround.settings.volume
        Dim VSVol As Integer = Voice.settings.volume
        Dim SFxSVol As Integer = SndFX.settings.volume
        Do While GetTimer() < Finish
            ' Do other processing while fading
            If SoundThread = BGSnd Then
                BackGround.settings.volume = Int((Finish - GetTimer()) / Time * BGSVol)
            ElseIf SoundThread = VSnd Then
                Voice.settings.volume = Int((Finish - GetTimer()) / Time * VSVol)
            ElseIf SoundThread = SFSnd Then
                SndFX.settings.volume = Int((Finish - GetTimer()) / Time * SFxSVol)
            End If
            Application.DoEvents()
        Loop
    End Sub

    Public Sub FadeIn(ByVal SoundThread As Integer, ByVal Time As Double)
        Dim Start As Double = GetTimer()
        Dim Finish As Double = Start + Time   ' Set end time.
        'start from no volume
        If SoundThread = BGSnd Then
            BackGround.settings.volume = 0
        ElseIf SoundThread = VSnd Then
            Voice.settings.volume = 0
        ElseIf SoundThread = SFSnd Then
            SndFX.settings.volume = 0
        End If

        Do While GetTimer() < Finish
            ' Do other processing while fading
            If SoundThread = BGSnd Then
                BackGround.settings.volume = Int((1 - ((Finish - GetTimer()) / Time)) * BGVol)
            ElseIf SoundThread = VSnd Then
                Voice.settings.volume = Int((1 - ((Finish - GetTimer()) / Time)) * VVol)
            ElseIf SoundThread = SFSnd Then
                SndFX.settings.volume = Int((1 - ((Finish - GetTimer()) / Time)) * SFxVol)
            End If
            Application.DoEvents()
        Loop

    End Sub

    Public Sub SetVolume(ByVal SoundThread As Integer, ByVal Volume As Integer)
        If Volume >= 0 And Volume < 101 Then
            If SoundThread = BGSnd Then
                BackGround.settings.volume = Volume
            ElseIf SoundThread = VSnd Then
                Voice.settings.volume = Volume
            ElseIf SoundThread = SFSnd Then
                SndFX.settings.volume = Volume
            End If
        End If
    End Sub

    Public Sub Mute(ByVal SoundThread As Integer)
        If SoundThread = BGSnd Then
            BackGround.settings.mute = True
        ElseIf SoundThread = VSnd Then
            Voice.settings.mute = True
        ElseIf SoundThread = SFSnd Then
            SndFX.settings.mute = True
        End If
    End Sub

    Public Sub UnMute(ByVal SoundThread As Integer)
        If SoundThread = BGSnd Then
            BackGround.settings.mute = False
        ElseIf SoundThread = VSnd Then
            Voice.settings.mute = False
        ElseIf SoundThread = SFSnd Then
            SndFX.settings.mute = False
        End If
    End Sub

#End Region

    Private Function GetTimer()
        GetTimer = Microsoft.VisualBasic.DateAndTime.Timer
    End Function

End Module
